#!/bin/bash

# script name: ./nfs-storage-contents-g5k.sh

qterm -t quick
/usr/local/maui/bin/schedctl -k
rm -f /var/spool/torque/server_priv/serverdb

rm -rf /home/sblagodurov/storage2/clavis-rundir-p*
rm -f /home/sblagodurov/storage2/nodes
rm -f /home/sblagodurov/storage2/hosts
rm -f /home/sblagodurov/storage2/container-ips.txt
rm -f /home/sblagodurov/storage2/container-ctids.txt

HEAD_NODE=`hostname`
HEAD_NODE_IP=`/sbin/ifconfig ib0 | grep "inet addr" | awk -F: '{print $2}' | awk '{print $1}'`

/etc/init.d/vz stop
rm -rf /tmp/vz/
cp -pr /vz.copy/ /tmp/vz/

# deploying containers:
CUR_CTID=102
for i in `cat /home/sblagodurov/storage2/nodes.txt`;  do 
  CUR_NODE=$i;
  
  ssh $CUR_NODE "/etc/init.d/vz stop"
  ssh $CUR_NODE "rm -rf /tmp/vz/"
  ssh $CUR_NODE "cp -pr /vz.copy/ /tmp/vz/"

  # copying containers:
  ssh $CUR_NODE "tar -xpzf /root/103-g5k.tar.gz -C /root/"
  ssh $CUR_NODE "/root/103-g5k.sh $CUR_CTID $HEAD_NODE"
  CUR_CTID=`expr $CUR_CTID + 1`
  ssh $CUR_NODE "/root/103-g5k.sh $CUR_CTID $HEAD_NODE"
  CUR_CTID=`expr $CUR_CTID + 1`
  ssh $CUR_NODE "rm -fr /root/103-g5k"
done

sed -i 's/np=4/np=12/g' /home/sblagodurov/storage2/nodes

echo "" >> /etc/hosts
echo "" >> /etc/hosts
echo "# head node IP for sblagodurov Clavis-HPC framework" >> /etc/hosts
echo $HEAD_NODE_IP $HEAD_NODE >> /etc/hosts
echo "" >> /etc/hosts
echo "# OpenVZ container internal IPs for sblagodurov Clavis-HPC framework" >> /etc/hosts
cat /home/sblagodurov/storage2/hosts >> /etc/hosts
echo "# end OpenVZ container internal IPs for sblagodurov Clavis-HPC framework" >> /etc/hosts
echo "" >> /etc/hosts

/home/sblagodurov/storage2/hpc-upon-boot.sh

CUR_CTID=102
for i in `cat /home/sblagodurov/storage2/nodes.txt`;  do 
  CUR_NODE=$i;

  scp /etc/hosts $CUR_NODE:/etc/hosts

  ssh $CUR_NODE "cp /etc/hosts /vz/private/$CUR_CTID/etc/hosts"
  CUR_CTID=`expr $CUR_CTID + 1`
  ssh $CUR_NODE "cp /etc/hosts /vz/private/$CUR_CTID/etc/hosts"
  CUR_CTID=`expr $CUR_CTID + 1`

  ssh $CUR_NODE "/home/sblagodurov/storage2/hpc-upon-boot.sh"
done

echo $HEAD_NODE > /var/spool/torque/server_name
cp /home/sblagodurov/storage2/nodes /var/spool/torque/server_priv/nodes

chmod -Rf 755 /var 
chmod -Rf 777 /var/spool/torque/spool/
chmod +t /var/spool/torque/spool/
chmod -Rf 777 /var/spool/torque/undelivered/
chmod +t /var/spool/torque/undelivered/

pbs_server -t create
# make sure the polling of moms is infrequent, otherwise the moms may be marked as down during online migration 
# (and subsequently their jobs will be terminated)
qmgr -c 'set server node_check_rate = 1800'
qmgr -c 'set server node_ping_rate = 1800'
qmgr -c 'set server tcp_timeout = 1800'

qmgr -c 'create queue batch'
qmgr -c 'set queue batch queue_type = Execution'
qmgr -c 'set queue batch resources_default.nodes = 1'
qmgr -c 'set queue batch resources_default.walltime = 01:00:00'
qmgr -c 'set queue batch enabled = True'
qmgr -c 'set queue batch started = True'

qmgr -c 'set server scheduling = True'
qmgr -c "set server managers = root@$HEAD_NODE"
qmgr -c "set server operators = root@$HEAD_NODE"
qmgr -c 'set server default_queue = batch'
qmgr -c 'set server mom_job_sync = True'
qmgr -c 'set server keep_completed = 90000'

# check the configuration for pbs server:
qmgr -c 'p s'

chmod 777 /var/run/munge/munge.socket.2

sed -i 's/SERVERHOST            mauiserver/SERVERHOST            '$HEAD_NODE'/g' /usr/local/maui/maui.cfg

qterm -t quick
pbs_server
/usr/local/maui/sbin/maui
